#!/usr/bin/python3
import os
import sys
import datetime
import shutil
import subprocess
import pdb
import argparse # This has become hugely bloated and is really far more than I need

# create a new directory in a $home/work diretory
work_path = os.path.join( os.getenv("HOME"),  "work" )

if os.path.exists( work_path ) == False:
    os.mkdir( work_path )

mydir = os.path.join( work_path, datetime.datetime.now().strftime('%Y-%m-%d_%H-%M-%S'))
os.makedirs(mydir)

# find out what user wants to do
parser = argparse.ArgumentParser()
parser.add_argument( "--app" )
parser.add_argument( "--inputfiles", default=[] )
parser.add_argument( "--data-path", default="input-data" )
#parser.add_argument( "--output-path", default="trained-models" )
parser.add_argument( "--control-file", default="my_settings.py" )
args = parser.parse_args()

# copy some input files and application
full_cmd = args.app
#app_filename = args.app.split(os.sep)[-1]
app_filename = full_cmd.split()[0].split(os.sep)[-1]
print( app_filename )
full_work_path = os.path.join( mydir, app_filename )
shutil.copy( app_filename, full_work_path  )
shutil.copy( args.control_file, os.path.join( mydir, "my_settings.py" ) )

# create some symlinks in the future
# let's copy "control" files and symlink "datafiles"
#os.symlink( args.data_path, os.path.join( mydir, args.data_path.split( os.sep )[-1]).strip("'") )
# also handle command line params

# and go there
cachedir = os.getcwd()
os.chdir( mydir )


#os.symlink( input_path = args.data_path, args.data_path.split( os.sep )[-1] ) # need to think more about this.

# and run
for val in full_cmd.split()[1:]:
    print( val )
    full_work_path += " " + val
# store command line in file called cmdline
with open( "cmdline", "w" ) as outfile:
    outfile.write( full_work_path )

whathappened = subprocess.Popen( full_work_path.split(), stdout=subprocess.PIPE, stderr=subprocess.PIPE ) # shell=False, ???
stdout,stderr = whathappened.communicate()

with open( "stdout.txt", "wb" ) as stdout_file:
    stdout_file.write( stdout )
with open( "stderr.txt", "wb" ) as stderr_file:
    stderr_file.write( stderr )


# and come back
os.chdir( cachedir )

